﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace SfSchedule_WPF
{
    using System.Collections.Specialized;

    using Syncfusion.UI.Xaml.Schedule;

    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private bool isDeleteButtonPressed = false;
        public MainWindow()
        {
            InitializeComponent();
            this.Schedule.AppointmentCollectionChanged += Schedule_AppointmentCollectionChanged;
            this.PreviewKeyDown += MainWindow_PreviewKeyDown;
        }
        private void MainWindow_PreviewKeyDown(object sender, KeyEventArgs e)
        {
            if (e.Key == Key.Delete)
            {
                isDeleteButtonPressed = true;
            }
        }

        private void Schedule_AppointmentCollectionChanged(object sender, System.Collections.Specialized.NotifyCollectionChangedEventArgs e)
        {
            if (e.Action == NotifyCollectionChangedAction.Remove && this.isDeleteButtonPressed)
            {
                var deletedAppointment = e.OldItems[0] as ScheduleAppointment;
                this.Schedule.Appointments.Add(CreateAppointmentFromDeletedAppointmet(deletedAppointment));
                this.isDeleteButtonPressed = false;
            }
        }

        ScheduleAppointment CreateAppointmentFromDeletedAppointmet(ScheduleAppointment deletedAppointment)
        { 
            //Mapping needed properties
            var appointment=new ScheduleAppointment();
            appointment.StartTime = deletedAppointment.StartTime;
            appointment.EndTime = deletedAppointment.EndTime;
            appointment.Subject = deletedAppointment.Subject;
            appointment.AllDay = deletedAppointment.AllDay;
            appointment.AppointmentBackground = deletedAppointment.AppointmentBackground;
            return appointment;
        }
    }
}
